//+--------------------------------------------------------------------------+
//|                                                                          |
//|                                 Tools                                    |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                         copyright(c) 2014-2024                           |
//|                           www.zapsolution.com                            |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 01-20-2014 (MM-DD-YYYY)            |
//|                        Last revised : 06-25-2024 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#pragma once

#define long_proc_c typedef long (__cdecl *zProc)
#define short_proc typedef short (__stdcall *zProc)
#define long_proc typedef long (__stdcall *zProc)
#define char_proc typedef char* (__stdcall *zProc)
#define wchar_proc typedef WCHAR* (__stdcall *zProc)
#define strSize(s) ( sizeof(s) / sizeof(s[0]) )
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16)) 

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

long rWidth(IN RECT &r){
    return r.right - r.left;
}

long rHeight(IN RECT &r) {
    return r.bottom - r.top;
}

//WCHAR* STRL(long N) {
//    static WCHAR longstr[33] = {0};  // Ensure buffer is large enough
//    WCHAR temp[33] = {0};            // Temporary buffer for constructing the string
//    int i = 0, j = 0;
//    long num = N;
//
//    if (N == 0) {
//        longstr[0] = L'0';
//        longstr[1] = L'\0';
//        return longstr;
//    }
//
//    // Handle negative numbers
//    if (N < 0) {
//        longstr[j++] = L'-';
//        num = -N;
//    }
//
//    // Convert number to string
//    while (num != 0) {
//        temp[i++] = (num % 10) + L'0';
//        num /= 10;
//    }
//
//    // Reverse the temp string to get the final result
//    while (i > 0) { longstr[j++] = temp[--i]; }
//    longstr[j] = L'\0';  // Null-terminate the string
//
//    return longstr;
//}

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*)longstr;
}

void WindowRedraw (IN HWND hWnd) {
    RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN); // | RDW_FRAME);
}

// This function appends the source string (srce) to the destination string (dest).
// Assumes dest has enough space to hold the result.
// Returns 0 on success, -1 on error (e.g., if either pointer is NULL).
long Add_Str(OUT WCHAR* dest, IN const WCHAR* srce) {
    if (dest == NULL || srce == NULL) return -1; // Error: NULL pointer

    // Find the end of the destination string
    WCHAR* dest_end = dest;
    while (*dest_end != L'\0') { dest_end++; }

    // Append the source string to the destination string
    while (*srce != L'\0') {
        *dest_end = *srce;
        dest_end++;
        srce++;
    }

    // Null-terminate the result
    *dest_end = L'\0';

    return 0; // Success
}

WCHAR* BBTIME() {
    time_t now = time(0);
    tm tstruct;
    static WCHAR buf[16] = {0};
    if (localtime_s(&tstruct, &now) == 0) {
        wcsftime(buf, strSize(buf), L"%X", &tstruct);
        buf[5] = 32; buf[6] = 0; buf[7] = 0;
    }
    return buf;
}

WCHAR* safecopy(IN WCHAR* dst, IN const WCHAR* src, IN long dstSize = MAX_PATH) {
    wcsncpy(dst, src, (size_t) dstSize);
    //long nLen = lstrlenW(src);

    //// rather than wcscopy, this version protect against buffer overflow !
    //nLen = min(max(dstSize - 1, 0), nLen); if (nLen == 0) return NULL;

    //memmove(dst, src, nLen * sizeof(WCHAR));
    //dst[nLen] = L'\0';
    return dst;
}

WCHAR* tcsstr(WCHAR* String, const WCHAR* Pattern) {
    if (String == NULL || Pattern == NULL) return NULL; // Handle NULL input

    WCHAR* start = String; // Temporary pointer to traverse String
    int mi = -1; // Match index

    while (Pattern[++mi]) {
        // If end of String is reached before the end of Pattern
        if (start[mi] == 0) return NULL;

        // If characters do not match, reset pattern index and move start pointer
        if (start[mi] != Pattern[mi]) {
            start++;
            mi = -1;
        }
    }
    return start;
}

BOOL FileExist(const WCHAR* szFileSpec) {
    DWORD dwAttr = GetFileAttributes(szFileSpec);
    return ((dwAttr != INVALID_FILE_ATTRIBUTES) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
}

DWORD FileSize(const WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    DWORD nRet = 0;
    if (lstrlenW(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

WCHAR* TEMPpath() {
    static WCHAR buf[MAX_PATH];
    DWORD nSize = GetTempPath(GetTempPath(NULL, NULL), &buf[0]);
    return buf;
}

WCHAR* EXEpath() {
    static WCHAR zpath[MAX_PATH] = { 0 };
    if (lstrlen(zpath) == 0) {
        if (GetModuleFileNameW(0, zpath, MAX_PATH)) {
            long nLen = lstrlenW(zpath);
            long nPos = nLen;
            for (long K = 1; K <= nLen; K++) {
                if (zpath[nPos - K] != L'\\') { 
                    zpath[nPos - K] = NULL;
                } else {
                    break;
                }
            }
        }
    }
    return zpath;
}

void ClearMemory(IN void* mem, IN long nSize) {
    __stosb((PBYTE) mem, (BYTE) 0, (SIZE_T) nSize);
}

WCHAR* Path_Combine(OUT WCHAR* zResource, IN WCHAR* path, IN WCHAR* combine) {
    // This version try to protect from buffer overflow
    long nLenPath = lstrlenW(path), nLenCombine = lstrlenW(combine);
    ClearMemory(zResource, MAX_PATH * sizeof(WCHAR));
    if (nLenPath < MAX_PATH) {
        MoveMemory(zResource, path, nLenPath * sizeof(WCHAR));
        if (nLenPath + nLenCombine < MAX_PATH) {
            MoveMemory(&zResource[nLenPath], &combine[0], nLenCombine * sizeof(WCHAR));
        }
    }
    return zResource;
}

WCHAR* EXEresource() {
    static WCHAR zpath[MAX_PATH] = { 0 };
    static long done;
    if (done == 0) {
        Path_Combine(zpath, EXEpath(), L"Resource\\");
        done = -1;
    }
    return zpath;
}

WCHAR* Resource(IN WCHAR* sFile) {
    static WCHAR zpath[MAX_PATH];
    ClearMemory(zpath, sizeof(zpath));
    Path_Combine(zpath, EXEresource(), sFile);
    return zpath;
}

// Function to check if a character is in the remove set
bool is_remove_char(WCHAR ch, WCHAR* removeSet) {
    while (*removeSet != L'\0') {
        if (ch == *removeSet) {
            return true;
        }
        removeSet++;
    }
    return false;
}

// RTRIM function
WCHAR* RTRIM(WCHAR* MainStr, WCHAR* RemoveChar) {
    if (!MainStr || !RemoveChar)
        return MainStr;

    long mainLen = lstrlen(MainStr);
    while (mainLen > 0 && is_remove_char(MainStr[mainLen - 1], RemoveChar)) {
        MainStr[--mainLen] = L'\0';
    }

    return MainStr;
}

// LTRIM function
WCHAR* LTRIM(WCHAR* sBuf, WCHAR* RemoveChar) {
    while (*sBuf != L'\0' && is_remove_char(*sBuf, RemoveChar)) {
        sBuf++;
    }
    return sBuf;
}

// TRIM function
WCHAR* TRIM(WCHAR* sBuf, WCHAR* RemoveChar) {
    sBuf = LTRIM(sBuf, RemoveChar);
    sBuf = RTRIM(sBuf, RemoveChar);
    return sBuf;
}

void List_DeleteAll(IN HWND hList) {
    if (hList) SendMessage(hList, LB_RESETCONTENT, 0, 0);
}

void List_DeleteItem(IN HWND hList, IN long nIndex) {
     if (IsWindow(hList)) {
         if (nIndex > 0) {
             -- nIndex; // Because ListBox is zero based
             SendMessage(hList, LB_DELETESTRING, (WPARAM) nIndex, (LPARAM) 0);
         }
     }
}

LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (IsWindow(hList)) {
        if (lstrlen(zTmp)) nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp);
    }
    return nIndex;
}

long List_Count(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0);
    return nRet;
}

long List_FindString(IN HWND hList, IN WCHAR* zTmp) {
    long nIndex = 0;
    if (hList) {
        nIndex = (long) SendMessage(hList, LB_FINDSTRINGEXACT, -1, (LPARAM) zTmp);
        if (nIndex > -1) ++nIndex;
    }
    return nIndex;
}

void List_SelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex < 0) { hList = 0; }
    if (hList) {
        if (nIndex > 0) --nIndex; // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0); 
    }
}

WCHAR* List_GetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    ZeroMemory(szData, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

long List_GetCursel(IN HWND hList) {
    long nIndex = 0;
    if (IsWindow(hList)) {
       nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
       if (nIndex > -1) ++nIndex; // Because ListBox is zero based
    }
    return nIndex;
}

// Replacemnt for _wsplitpath
void wsplitpath(const WCHAR* path, WCHAR* drive, WCHAR* dir, WCHAR* fname, WCHAR* ext) {
    // Initialize components to empty strings
    if (drive) *drive = L'\0';
    if (dir) *dir = L'\0';
    if (fname) *fname = L'\0';
    if (ext) *ext = L'\0';

    const WCHAR* last_slash = NULL;
    const WCHAR* last_dot = NULL;
    const WCHAR* p = path;

    // Check for drive letter
    if (path && path[1] == L':') {
        if (drive) {
            drive[0] = path[0];
            drive[1] = L':';
            drive[2] = L'\0';
        }
        p += 2;
    }

    // Find the last slash and dot
    for (; p && *p; ++p) {
        if (*p == L'/' || *p == L'\\') {
            last_slash = p;
        } else if (*p == L'.') {
            last_dot = p;
        }
    }

    // Separate directory and filename
    if (last_slash) {
        if (dir) {
            size_t len = last_slash - path + 1;
            safecopy(dir, path, (long) len);
            dir[len] = L'\0';
        }
        path = last_slash + 1;
    }

    // Separate filename and extension
    if (last_dot && last_dot > last_slash) {
        if (fname) {
            size_t len = last_dot - path;
            safecopy(fname, path, (long) len);
            fname[len] = L'\0';
        }
        if (ext) {
            safecopy(ext, last_dot, _MAX_EXT - 1);
            ext[_MAX_EXT - 1] = L'\0';
        }
    } else if (fname) {
        if (path) {
            safecopy(fname, path, _MAX_FNAME - 1);
            fname[_MAX_FNAME - 1] = L'\0';
        }
    }
}

void Randomize() {
    srand ((DWORD)time(0));
}

long Random(IN long low, IN long high) {
    return low + rand() % (high - low + 1);
}
